
#include <iostream>
#include <numa.h>
#include <numeric>
#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"
#include <vector>
#include <cmath>
#include <climits>
#include <limits>
#include "accumulate.h"


typedef long int  val_t ;
#define VECTOR


template<class T>
struct my_op {

 T operator()(T a, T b) {
 
  volatile double d;
  for(int i=1; i < 100000; i++) d = sin(1000);

  return (a+b);
 }
};

val_t min(val_t a, val_t b) {
  if(a < b) return a;
  else return b;
}

int main(int argc, char ** argv) {
      
	    
      int size = (argc > 1)?atoi(argv[1]):100000000;
      int nthread = (argc > 2)?atoi(argv[2]):1;
      int c = (argc > 3)?atoi(argv[3]):100;
      int v = (argc > 4)?atoi(argv[4]):0;

       
       #ifndef VECTOR
       val_t *data = new val_t[size];
       #else
       std::vector<val_t> data(size);
       #endif
       std::cout << "size =" << size << std::endl;
       for(int i =0; i < size; i++) data[i] = val_t(i+1);
 
       tbb::task_scheduler_init init(nthread);

       tbb::tick_count t0, t1;
       std::cout << "***********Start of computation**********" << std::endl;
       val_t res;
       val_t MAX_V = std::numeric_limits<val_t>::max();
       t0 = tbb::tick_count::now();
         #ifndef VECTOR
         res = tbb_adapt::accumulate(data, data+size, val_t(10), my_op<val_t>(), c) ;
         #else
         res = tbb_adapt::accumulate(data.begin(), data.end(), MAX_V, min/*my_op<val_t>()*/, c) ;
         #endif
       t1 = tbb::tick_count::now();

       std::cout << "-----------------------------------" << std::endl;
       printf (": time = %.6f s\n", (t1-t0).seconds());
       std::cout << ": res = " << res << std::endl;
       std::cout << std::endl;
       std::cout << "-----------------------------------" << std::endl;

      if(v) {
       val_t res_stl;
       #ifndef VECTOR
       res_stl = std::accumulate(data, data+size, val_t(0)); //STL
       #else
       res = std::accumulate(data.begin(), data.end(), MAX_V, min) ;
       #endif
       std::cout << "res_stl = " << res_stl << std::endl;
       if(res_stl-res < 1e-6)
              std::cout << "Le calcul est correct OK! " << std::endl;
       else { std::cout << "Le calcul n'est pas correct KO!  " << std::endl;
          std::cout << res << "!=" << res_stl << std::endl; 
       } 
      }
      #ifndef VECTOR
      delete data;  
      #endif  
  return 0;
};

