#ifndef _JUMP_WORK_H_
#define _JUMP_WORK_H_

/*
 * Date : 26/03/2009
 * Author: D. Traore
 */

#include "tbb_adapt.h"

namespace tbb_adapt {

//Jump work class
class NextJumpWork : public tbb_adapt::NextJump {
     int _beg;
     int _end;

   public :
     NextJumpWork(int beg=0, int end=0): NextJump(), _beg(beg), _end(end) { }
     void init(int beg, int end) { _beg = beg; _end = end; }
     int get_end() const { return _end;}
     void set_end(int end){ _end = end;}
     int  get_beg() const { return _beg;}
     void set_beg(int beg) {  _beg = beg;}
     bool is_empty() const { return _end <= _beg; }
};

class NextJumpWork2d : public tbb_adapt::NextJump {

     int _beg;
     int _end;
     int _beg2;
     int _end2;



   public :
     NextJumpWork2d(int beg=0, int end=0, int beg2=0, int end2=0): NextJump(), _beg(beg), _end(end),
                                                              _beg2(beg2), _end2(end2) { }
     void init(int beg, int end, int beg2, int end2) { _beg = beg; _end = end; _beg2 = beg2; _end2 = end2; }
     int get_end() const { return _end;}
     void set_end(int end){ _end = end;}
     int  get_beg() const { return _beg;}
     void set_beg(int beg) {  _beg = beg;}

     int get_end2() const { return _end2;}
     void set_end2(int end2){ _end2 = end2;}
     int  get_beg2() const { return _beg2;}
     void set_beg2(int beg2) {  _beg2 = beg2;}

     bool is_empty() const { return (_end <= _beg) && (_end2 <= _beg2); }
 };
}
#endif
