
#include <iostream>
#include <numa.h>
#include <numaif.h>
#include <sys/mman.h>
#include "merge.h"


#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"


typedef double val_t ;
//typedef pair<double, int> val_t;


template<typename T1, typename T2, typename Comparator >
class my_pair_compare
{

        public:

        bool operator()(const std::pair<T1, T2>& p1,  const std::pair<T1, T2>& p2)
        {
            if( Comparator()(p1.first, p2.first))
                        return true;
            if(Comparator()(p1.second, p1.second) )
                        return true;
             return false;
        }

};


template<class T>
void is_sorted(T* output, int sz)
{
     bool is_sorted = true;
     for(int i=1; i < sz; i++) {
         if(output[i-1] > output[i]) {
             std::cout << "output[" << i-1 << "]=" << output[i-1] << " is not less than  ";
             std::cout << "output[" << i << "]=" << output[i] << ", " << std::endl;
             std::cout << "Then the table is not sorted well" << std::endl;
             is_sorted = false;
           break;
        }
     }
    if(is_sorted) std::cout << "0:The table has been well sorted..........";
    std::cout << std::endl;
}

int main(int argc, char ** argv) {
 
	    
      int size = (argc > 1)?atoi(argv[1]):100000000;
      int nthread = (argc > 2)?atoi(argv[2]):1;
      int c = (argc > 3)?atoi(argv[3]):100;
      int ch = (argc > 4)?atoi(argv[4]):1;


     unsigned long numa_node = 255;
     val_t *data = (val_t *)mmap(0, (size)*sizeof(val_t),PROT_READ|PROT_WRITE,
                                 MAP_PRIVATE|MAP_ANONYMOUS,0,0);

     val_t *data2 = (val_t *)mmap(0, (size)*sizeof(val_t),PROT_READ|PROT_WRITE,
                                 MAP_PRIVATE|MAP_ANONYMOUS,0,0);

     val_t *output = (val_t *)mmap(0, (2*size)*sizeof(val_t),PROT_READ|PROT_WRITE,
                                 MAP_PRIVATE|MAP_ANONYMOUS,0,0);

      std::pair<double, int> pair_test;
      pair_test = std::make_pair(1, 0);

      
      std::cout << "size =" << size << std::endl;
       
       srand48(0);
       for(int i =0; i < size; i++) data[i] = i+1; /*lrand48()*/; //std::sort(data, data+size);
       for(int i =0; i < size; i++) data2[i] = 2*(i+1); /*lrand48()*/; //std::sort(data2, data2+size);

       //srand48(0);
       //for(int i =0; i < size; i++) data[i]  = make_pair(/*lrand48()*/i, /*lrand48()*/2*i);
       //std::sort(data, data+size, my_pair_compare<double, int, less<double> >());
       //for(int i =0; i < size; i++) data2[i] = make_pair(/*lrand48()*/2*i, /*lrand48()*/i);
       //std::sort(data2, data2+size, my_pair_compare<double, int, less<double> >());


        //std::cout << "***********debut de la fusion*************" << std::endl;

       tbb::task_scheduler_init init(nthread);

       tbb::tick_count t0, t1;
       val_t res;
       t0 = tbb::tick_count::now();
       if(ch==1) {
          std::cout << "fusion parallel adaptative" << std::endl; 
          res = *(tbb_adapt::merge(data, data+size, data2, data2+size, output)-1) ;
          //my_pair_compare<double, int, less<double> > mpc;
         // adapt_merge(data, data+size, data2, data2+size, output, mpc, c);
       }
       else {
          std::cout << "fusion sequentiel STL" << std::endl;
          res = *(std::merge(data, data+size, data2, data2+size, output)-1);
         // my_pair_compare<double, int, less<double> > mpc;
         //std::merge(data, data+size, data2, data2+size, output, mpc);

       }
       t1 = tbb::tick_count::now();

       std::cout << "-----------------------------------" << std::endl;
       printf (": time = %.6f s\n", (t1-t0).seconds());
       std::cout << ": res = " << res << std::endl;
       std::cout << "-----------------------------------" << std::endl;

      /*for(int i =0; i < 2*size; i++) {
         if(i < size) { 
          cout << "data[" << i << "]=" << data[i] ;
          cout << ", data2[" << i << "]=" << data2[i] ;
         }
         else {
          cout << "                     ";
         }
          cout << ", output[" << i << "]=" << output[i] << endl;
       }*/

       is_sorted(output, 2*size);

       numa_free(data, size*sizeof(val_t));  
       numa_free(data2, size*sizeof(val_t)); 
       numa_free(output, 2*size*sizeof(val_t)); 
    
  return 0;
};

