#include "partition.h"

#include "getoptions.h"

#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"

//#define SLODOWN

template <typename T, typename cmp=std::less<T> >
struct less_than_median
{
  T _value;
  less_than_median(){};
  less_than_median(T value):_value(value){ }
  bool operator()(T value) {

    #ifdef SLODOWN
    volatile double d;
    for (int i=0; i<10000; ++i)
      d =  sin(1000);
    #endif

     return cmp()(value, _value);
  }
};

template<class T>
bool IsOdd (T i) { return (i%2)==1; }

template<typename T> 
void affich(T* tab, size_t sz)
{
  for(size_t i=0; i < sz; i++) 
	  std::cout << "tab[" << i << "]=" << tab[i] << " ; ";
  std::cout << std::endl;
  std::cout << std::endl;
}

template<typename T>
struct alea {
   int _max;
   alea(int max):_max(max){ }
   T operator()() {
     return (T(rand())/RAND_MAX)*_max;
   }
};

template<class In, class Predicate>
void verif_partition(In first, In split, In last, Predicate pred)
{
   size_t s1 = split-first;
   size_t s2 = last-split;
   size_t i=0;
   size_t j=0;
   while((first!=split)&&(pred(*first++)))  i++;
   while((split!=last)&&(!pred(*split++)))  j++;
   std::cout << "s1= " << s1 << ", s2=" << s2 << std::endl;
   std::cout << "i= " << i << ", j=" << j << std::endl;
   if((i==s1)&&(j==s2)) std::cout << "The table has been well partionned..." << std::endl;
   else std::cout << "The table has not been well partionned..." << std::endl;

}

typedef long val_t;

int main (int argc, char ** argv) {
      size_t sz =  100000000;
      int nthread = 1;
      int db, v, s, help;
      int c = 100;
      char * specifiers [] = { (char*)"-n", (char*)"-np", (char*)"-bsize", (char*) "-c", (char*)"-s", 
        (char*)"-db", (char*)"-v", (char*)"-h" ,0};
      int opt_types[] = {INTARG, INTARG, INTARG, INTARG, BOOLARG, BOOLARG, BOOLARG, BOOLARG, 0};
      get_options(argc, argv, specifiers, opt_types, &sz, &nthread, &tbb_adapt::block_size, &c, &s, &db, &v, &help, 0);

      tbb::task_scheduler_init init(nthread);
 
      val_t *split;
      val_t* tab = new val_t[sz];
      std::cout << "Computation with size = " << sz << std::endl;
      for(int i =0; i < sz; i++) tab[i] = i;
      //for(int i =0; i < sz; i++) tab[i] = lrand48();
      //std::generate(tab, tab+sz, alea<double>(sz));
      
      val_t median = val_t(std:: __median(*tab, *(tab+sz/2), *(tab+sz-1)));
    
      if(db) tbb_adapt::PARTITION_BLOC_SELECTION = tbb_adapt::DYNAMIC;  

      tbb::tick_count t0, t1;
      std::cout << "-----------------------------------" << std::endl;
      t0 = tbb::tick_count::now();
      if(!s) {
        std::cout << "Adaptive partition" << std::endl;
        split = tbb_adapt::partition(tab, tab+sz, IsOdd<val_t> /*less_than_median<double>(median)*/);
      } else {
        std::cout << "STL partition " << std::endl;
        split = std::partition(tab, tab+sz, IsOdd<val_t> /*less_than_median<double>(median)*/);
      }
      t1 = tbb::tick_count::now();
      printf (": time = %.6f s\n", (t1-t0).seconds());
      std::cout << "-----------------------------------" << std::endl;

      if(v){
          std::cout << "*******Debut verification*******" << std::endl;
           verif_partition(tab, split, tab+sz, IsOdd<val_t> /*less_than_median<double>(median)*/);

           std::cout << "affichage des 10 premiers elements...." << std::endl;
           for(int i= 0; i < 10; i++) std::cout << "data[" << i << "]=" << tab[i] << std::endl;

          std::cout << "*******Fin verification*******" << std::endl;
      }


 return 0;
}

