
#include <iostream>
#include <numa.h>
#include <numaif.h>
#include <sys/mman.h>
#include <signal.h>
#include <string>

#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"
#include "tbb/parallel_sort.h"
#include "sort.h"

#define DOUBLE_TYPE

#ifdef DOUBLE_TYPE
typedef int val_t ;
#endif

#ifdef STRING_TYPE
typedef std::string val_t ;
#endif

template <typename T>
struct my_less
{
  T _value;
  my_less(){};
  bool operator()(T a, T b) {

     
    volatile double d;
    for (int i=0; i< 255; ++i)
     for(int j=0; j < 255; ++j)
       if( i < j ) {
         d = 5;
       }

     return std::less<T>()(a, b);
  }

  bool operator()(T a, T b) const {


    volatile double d;
    for (int i=0; i< 255; ++i)
     for(int j=0; j < 255; ++j)
       if( i < j ) {
         d = 5;
       }

     return std::less<T>()(a, b);
  }

};


struct my_random_string {
  
   const std::string letters;
   const size_t size;
 
   my_random_string(const std::string _letters, const size_t _size): letters(_letters), size(_size) { }

   std::string operator()() {
      std::string tmp;
      static int cpt = 0;
      ++cpt;
      for(int i=0; i < 20; i++) {
         int pos = size*drand48();
         tmp += letters[pos];
      }
    return tmp; 
   } 
};

template<class T>
bool is_sorted(T* output, int sz)
{
     bool is_sorted = true;
     for(int i=1; i < sz; i++) {
         if(output[i-1] > output[i]) {
             std::cout << "output[" << i-1 << "]=" << output[i-1] << " is not less than  ";
             std::cout << "output[" << i << "]=" << output[i] << ", " << std::endl;
             std::cout << "Then the table is not sorted well" << std::endl;
             is_sorted = false;
           break;
        }
     }
    //if(is_sorted) std::cout << a1::System::getRank() << ":The table has been well sorted..........";
    //std::cout << std::endl;
return is_sorted;
}

int main(int argc, char ** argv) {
      

      int size = (argc > 1)?atoi(argv[1]):100000000;
      int nthread = (argc > 2)?atoi(argv[2]):1;
      int ch = (argc > 3)?atoi(argv[3]):1;
      tbb_adapt::sort_grain_size  = (argc > 4)?atoi(argv[4]):10000;

      #ifdef DOUBLE_TYPE
      unsigned long numa_node = 255;
      val_t *data = (val_t *)mmap(0, (size)*sizeof(val_t),PROT_READ|PROT_WRITE,
                                 MAP_PRIVATE|MAP_ANONYMOUS,0,0);
      if (mbind(data,size*sizeof(val_t),MPOL_INTERLEAVE,&numa_node,64,0) != 0)
      {
          perror("mbind");
      }
        
       //pour les doubles
       srand48(0);
       for(int i =0; i < size; i++) data[i] = lrand48()/*drand48()*/;
   
       #endif


       #ifdef STRING_TYPE

        val_t data[size];       
        std::string letters = "abcdefghijklmnopqrstuvwxyz";
        std::cout << "letters.size() = " << letters.size() << std::endl;
        my_random_string my_string(letters, letters.size());
       //pour les string
        for(int i =0; i < size; i++)  data[i] = my_string();

       #endif

       std::cout << "********start computation with size =" << size << "*********" << std::endl;
       std::cout << "size = " << size << std::endl;

       tbb::task_scheduler_init init(nthread);

       tbb::tick_count t0, t1;
       t0 = tbb::tick_count::now();

       if(ch==1) {
          std::cout << "Sort adaptatif" << std::endl;
          tbb_adapt::sort(data, data+size /*, my_less<val_t>()*/); 
       } else if(ch==2) {
          std::cout << "Sort TBB" << std::endl;
          tbb::parallel_sort(data, data+size /*, my_less<val_t>()*/);
       }
       else {
          std::cout << "Sort sequentiel STL" << std::endl;
          std::sort(data, data+size /*, my_less<val_t>()*/); 
       }
       t1 = tbb::tick_count::now();

       std::cout << "-----------------------------------" << std::endl;
       printf (": time = %.6f s\n", (t1-t0).seconds());
       std::cout << std::endl;
       std::cout << "-----------------------------------" << std::endl;

       if(is_sorted(data, size)) 
         std::cout << ":The table has been well sorted.........." << std::endl;

       #ifdef DOUBLE_TYPE
       numa_free(data, size*sizeof(val_t));  
       #endif
  return 0;
};

