
#include <iostream>
#include <numa.h>
#include <numaif.h>
#include <sys/mman.h>
#include <signal.h>

#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"
#include "stable_sort.h"

#define VECTOR

typedef long val_t ;


template <typename T>
struct less_than
{
   bool operator()(T first, T second) {
     return (first < second);
   }
};


template <typename T>
struct greater_than 
{

  bool operator()(T first, T second) {
     return (first > second);
  }

};

template<class T, class Compare>
bool is_sorted(T output, int sz, Compare cmp)
{
     bool is_sorted = true;
     for(int i=1; i < sz; i++) {
         if(cmp(output[i], output[i-1])) {
             std::cout << "output[" << i-1 << "]=" << output[i-1] << " is not less than  ";
             std::cout << "output[" << i << "]=" << output[i] << ", " << std::endl;
             std::cout << "Then the table is not sorted well" << std::endl;
             is_sorted = false;
           break;
        }
     }
    //if(is_sorted) std::cout << "0:The table has been well sorted..........";
    //std::cout << std::endl;
return is_sorted;
}

int main(int argc, char ** argv) {
      

      int size = (argc > 1)?atoi(argv[1]):100000000;
      int nthread = (argc > 2)?atoi(argv[2]):1;
      int c = (argc > 3)?atoi(argv[3]):100;
      tbb_adapt::seuil = (argc > 4)?atoi(argv[4]):10000;
      int ch = (argc > 5)?atoi(argv[5]):1;


      #ifndef VECTOR
      unsigned long numa_node = 255;
      val_t *data = (val_t *)mmap(0, (size)*sizeof(val_t),PROT_READ|PROT_WRITE,
                                 MAP_PRIVATE|MAP_ANONYMOUS,0,0);
      if (mbind(data,size*sizeof(val_t),MPOL_INTERLEAVE,&numa_node,64,0) != 0)
      {
          perror("mbind");
      }
      #else
       std::vector<val_t> data(size);
      #endif
      std::cout << "********start computation with size =" << size << "*********" << std::endl;
       
       srand48(0);
       for(int i =0; i < size; i++) data[i] = i/*drand48()*/;

       tbb::task_scheduler_init init(nthread);

       tbb::tick_count t0, t1;
       t0 = tbb::tick_count::now();
       if(ch==1) {
          std::cout << "stable sort adaptatif" << std::endl;
          #ifndef VECTOR
          tbb_adapt::stable_sort(data, data+size); 
          #else
          tbb_adapt::stable_sort(data.begin(), data.end(), greater_than<val_t>(), c);
          #endif
       } else {
          std::cout << "stable sort sequentiel STL" << std::endl;
          #ifndef VECTOR
          std::stable_sort(data, data+size); 
          #else
          std::stable_sort(data.begin(), data.end(), greater_than<val_t>());
          #endif
       }
       t1 = tbb::tick_count::now();

       std::cout << "-----------------------------------" << std::endl;
       printf (": time = %.6f s\n", (t1-t0).seconds());
       std::cout << "-----------------------------------" << std::endl;

       if(is_sorted(data, size, greater_than<val_t>()/*std::less<val_t>()*/)) 
         std::cout << "0:The table has been well sorted.........." << std::endl;

       std::cout << "affichage des 10 premiers elements...." << std::endl;
       for(int i= 0; i < 10; i++) std::cout << "data[" << i << "]=" << data[i] << std::endl; 
 
       #ifndef VECTOR
       numa_free(data, size*sizeof(val_t));  
       #endif
  return 0;
};

