
#include <iostream>
#include <numa.h>
#include "tbb/task_scheduler_init.h"
#include "tbb/tick_count.h"
#include <cmath>
#include "transform.h"


typedef double val_t ;
#define VECTOR
//#define BINARY_OP


template<class T>
struct my_fct {
    my_fct(){ };
    T operator()(T a){
         return  2*a;
      //return sin(a);
    }
};

val_t my_bin_op (val_t a, val_t b) { return a*b; }

template<class T1, class T2>
bool verif (T1 first, T1 last, T2 res) {
     int i = 0;
     int cpt = 0;
     bool is_ok = true;
     if(*first!=*res) {
      std::cerr << "Erreur: res[" << i << "]=" << *res << "!=" << *first << std::endl;
      is_ok=false;
     }
     while(++first!=last) {
       ++res;
       i++;
       if(*first!=*res) {
        cpt++;
        if(cpt < 10)  std::cerr << "Erreur: res[" << i << "]=" << *res << "!=" << *first << std::endl;
        is_ok=false;
      }
     }
 return is_ok;
}


int main(int argc, char ** argv) {
      
	    
      int size = (argc > 1)?atoi(argv[1]):100000000;
      int nthread = (argc > 2)?atoi(argv[2]):1;
      int c = (argc > 3)?atoi(argv[3]):100;      

      #ifndef VECTOR
       val_t *data = new val_t[size];
       val_t *output = new val_t[size];
       #else
       std::vector<val_t> data(size);
       std::vector<val_t> output(size);
       #endif
 
       std::cout << "size =" << size << std::endl;
       for(int i =0; i < size; i++) data[i] = i+1;

       tbb::task_scheduler_init init(nthread);
 
       tbb::tick_count t0, t1;
       std::cout << "***********Start of computation**********" << std::endl;       
       t0 = tbb::tick_count::now();
       val_t res;
        #ifndef BINARY_OP
         #ifndef VECTOR
         res = *(tbb_adapt::transform(data, data+size, output, my_fct<val_t>())-1) ;
         #else
         res = *(tbb_adapt::transform(data.begin(), data.end(), output.begin(), my_fct<val_t>())-1) ;
         #endif
        #else
         #ifndef VECTOR
         res = *(tbb_adapt::transform(data, data+size, data, output, my_bin_op)-1) ;
         #else
         res = *(tbb_adapt::transform(data.begin(), data.end(), data.begin(), output.begin(), my_bin_op)-1) ;
         #endif
        #endif
       t1 = tbb::tick_count::now();

       std::cout << "-----------------------------------" << std::endl;
       printf (": time = %.6f s\n", (t1-t0).seconds());
       std::cout << "res = " << res << std::endl;
       std::cout << std::endl;
       std::cout << "-----------------------------------" << std::endl;


       val_t* output2 = new val_t[size];
       val_t res_stl;
       #ifndef BINARY_OP
        #ifndef VECTOR
        res_stl = *(std::transform(data, data+size, output2, my_fct<val_t>())-1); //STL
        #else
        res_stl = *(std::transform(data.begin(), data.end(), output2, my_fct<val_t>())-1); //STL
        #endif
       #else
        #ifndef VECTOR
        res_stl = *(std::transform(data, data+size, data, output2, my_bin_op)-1); //STL
        #else
        res_stl = *(std::transform(data.begin(), data.end(), data.begin(), output2, my_bin_op)-1); //STL
        #endif
       #endif

       #ifndef VECTOR
       if(verif(output2, output2+size, output)) 
       #else
       if(verif(output2, output2+size, output.begin()))
       #endif
       {
              std::cout << "Le calcul est correct  " << std::endl;
              std::cout << "res_stl = " << res_stl << std::endl;
       }
       else {
             std::cout << "Le calcul n'est pas correct  " << std::endl;
             std::cout << "res_stl = " << res_stl << std::endl;
       }
       delete [] output2;

       //AFFICHAGE des 10 premiers resultats
       for(int i = 0; i < 10; i++) {
         std::cout << "output[" << i << "]=" << output[i] << std::endl;
       }

       #ifndef VECTOR
       delete [ ] data;
       delete [] output; 
       #endif
  return 0;
};


