
#include <sys/time.h>

/***************************************************************************/

/* TimeLoop permet d'augmenter le temps de calcul
 * d'une operation.
 * Le temps est proportionnel a TIMELOOP^2
 * Attention: La valeur de x est modifiee mais pas celle de y.
 */


double gettime() ;
void init_timeloop(double milliseconds_comp) ;
  // Intialise TIMMAX a une valeur telle qu'une boucle de calcul coute 
  // milliseconds_comp ms.

// Pour l'utilisation :
// TimeLoop ( unsigned int *x ) ;   // Effectue une operation de duree milliseconds_comp
// milliseconds. 
//
// A condition d'avoir defini: TIME_LOOP_SLOW_DOWN


//#define TIME_LOOP_SLOW_DOWN 


#ifdef TIME_LOOP_SLOW_DOWN
  void  TimeLoopFn(unsigned int* x, unsigned int *y) ;
  #define TimeLoop(x) if (TIMEMAX >0) TimeLoopFn( (unsigned int*) &x, (unsigned int*) &x) ;
#else
  #define TimeLoop(x) { }
#endif

#ifdef FILETIME_CPP
double TIMEMAX ; 
#else
extern double TIMEMAX ; 
#endif 


